<?php
/**
 * VerificationChannel
 *
 * PHP version 7.4
 *
 * @category Class
 * @package  YCloud\Client
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * YCloud API
 *
 * The [YCloud](https://ycloud.com) API is organized around [REST](https://en.wikipedia.org/wiki/Representational_state_transfer). Our API is designed to have predictable, resource-oriented URLs, return [JSON](https://www.json.org) responses, and use standard HTTP response codes and verbs.
 *
 * The version of the OpenAPI document: v2
 * Contact: service@ycloud.com
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.1.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace YCloud\Client\Model;
use \YCloud\Client\ObjectSerializer;

/**
 * VerificationChannel Class Doc Comment
 *
 * @category Class
 * @description Supports several independent channels for verification: &#x60;sms&#x60;: Sends an SMS message with a verification code. &#x60;voice&#x60;: Makes a voice call with a verification code. &#x60;email_code&#x60;: Sends an email with a verification code. &#x60;whatsapp&#x60;: Sends a WhatsApp message with a verification code.
 * @package  YCloud\Client
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class VerificationChannel
{
    /**
     * Possible values of this enum
     */
    public const SMS = 'sms';

    public const VOICE = 'voice';

    public const EMAIL_CODE = 'email_code';

    public const WHATSAPP = 'whatsapp';

    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public static function getAllowableEnumValues()
    {
        return [
            self::SMS,
            self::VOICE,
            self::EMAIL_CODE,
            self::WHATSAPP
        ];
    }
}


